﻿(function (app) {
    app.controller('myCtrl', ["$scope","$ionicTabsDelegate", "$state", "$http", "storage", "myService", "common", "config", "msg","$timeout"
        , function ($scope,$ionicTabsDelegate, $state, $http, storage, myService, common, config, msg, $timeout) {
        $scope.$on('$ionicView.beforeEnter', function (viewResult) {
            $ionicTabsDelegate.showBar(true);
            myService.myInfo().then(function(result){ 
              $scope.user = result.data.data
            });
        });
        $scope.setAvator = function () {
            common.setAvator().then(function (result) {
                var response = JSON.parse(result.response);
                $timeout(function () {
                    $scope.user.avatar = config.imgServer + response.data.md5;
                });
            });
        };

    }]);
    app.controller('profileCtrl', ["$scope", "$timeout","$ionicTabsDelegate","$state","$filter", "storage", "myService", "msg", "common"
      , function ($scope, $timeout, $ionicTabsDelegate, $state, $filter, storage, myService, msg, common) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });
            $scope.setAvator = function () {
                common.setAvator().then(function (result) {
                    var response = JSON.parse(result.response);
                    $timeout(function () {
                      $scope.vm.avatar = config.imgServer + response.data.md5;
                    });
                });
            };
          
          //保存个人信息
            $scope.vm={
                pic:"",
                sex:"",
                signture:"",
                emotion:"",
                job:"",
                tall:""
            };
            $scope.$on('$ionicView.beforeEnter', function () {
                msg.loading();
                myService.myInfo().then(function(result){
                  // alert(JSON.stringify(result.data.data));
                  $scope.vm = result.data.data;
                  $scope.vm.sex = $scope.vm.sex+'';
                  $scope.vm.emotion = $scope.vm.emotion+'';
                  if($scope.vm.birthday){
                      var arr1 = $scope.vm.birthday.split("-");  
                      $scope.vm.birthday1 = new Date(arr1[0],parseInt(arr1[1])-1,arr1[2]); 
                  }
                  msg.hide();

                },function(error){
                  msg.hide();
                  // msg.error(error.data.message);
                })
            });
 
            $scope.saveMaterial = function(){
                var data = {
                    sex:$scope.vm.sex,
                    signture:$scope.vm.signture,
                    emotion:$scope.vm.emotion,
                    work:$scope.vm.work, 
                    height:$scope.vm.height, 
                    city:$scope.vm.city
                }; 
                if($scope.vm.birthday1){
                    data.birthday = $filter('date')($scope.vm.birthday1, "yyyy-MM-dd");
                }
                if($scope.vm.avatar){
                  data.pic = $scope.vm.avatar;
                }
                msg.loading('提交中...');
 
                myService.saveMaterial(data).then(function(result){
                  msg.hide();
                  msg.success("保存成功!");
                  $state.go('app.my');
                    myService.myInfo();
                },function(error){
                  msg.hide();
                  msg.error(error.data.message);
                })
            }
        }]);
    app.controller('settingCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
     , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });
            //退出登陆
            $scope.logout = function(){
                storage.remove("token");
                storage.remove("user");
                $state.go("login");
            }

     }]);
    app.controller('aboutMiaoCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('withdrawCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('payoutCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('payExplainCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('explainCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('contactCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('attentionCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {
            $scope.toDetail = function(){
                $state.go("app.attention_Detail");
            }
        }]);

    app.controller('attention_DetailCtrl', ["$scope", "$state", "$ionicModal","storage","msg", "common", "config", "homeService", "$ionicTabsDelegate", "$stateParams", "$ionicModal", "$timeout", "$ionicScrollDelegate", "$interval"
        , function ($scope, $state,$ionicModal, storage , msg, common, config, homeService, $ionicTabsDelegate, $stateParams, $ionicModal, $timeout, $ionicScrollDelegate, $interval) {
            var id = $stateParams.id;
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });
            $scope.load = function (id) {
                msg.loading();
                homeService.dreamDetail(id).then(function (result) {
                    msg.hide();
                    $scope.user = result.data.data;
                }, function (error) {
                    msg.hide();
                });
            };
            $scope.load(id);

            $scope.cancelSupport = function () {
                $scope.tosupport = false;
                $scope.toshare = false;

            };
            $scope.toshare = false;
            $scope.share = function ($event) {
                $event.stopPropagation();
                $scope.toshare = true;
            };
            $scope.shareDream = function(){
                $state.go("app.shareDream",{item:$scope.user});
            };
            $scope.toDetail = function (id) {
                $state.go('app.home_dreamdetail',{id:id});
            };
            $scope.toOldDream = function(){
                $state.go("app.oldDream");
            };
            $scope.toSupportDream = function(){
                $state.go("app.supportDream");
            };
            $scope.collectionDream = function(is_collection){
                homeService.collectionDream(id,is_collection).then(function(result){
                    $scope.user.is_collection=result.data.data;
                })
            };
        }]);

    app.controller('messageReplyCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('personalLetterCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg","storage"
        , function ($scope,$ionicTabsDelegate, $state,myService, msg, storage) {

        }]);
    app.controller('rechargeCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg"
  , function ($scope, $ionicTabsDelegate,$state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
                myService.myInfo().then(function(result){
                    $scope.vm = result.data.data;
                    $scope.vm.money = '';
                })
            });
            $scope.payExplain = function(){
                $state.go("app.payExplain")
            };
            $scope.withdraw = function(){
                $state.go("app.withdraw")
            };
      //充值
      $scope.recharge = function(money){
          myService.recharge(money).then(function(result){
              msg.text("充值成功");
            $state.go('app.my');
          });
      }

  }]);
    app.controller('payCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                myService.myInfo().then(function(result){
                    $scope.vm = result.data.data;
                    $scope.vm.money = '';
                })
            });
            $scope.payExplain = function(){
                $state.go("app.explain")
            };
            $scope.withdraw = function(){
                $state.go("app.payout")
            };
            //充值
            $scope.recharge = function(money){
                myService.recharge(money).then(function(result){
                    msg.text("充值成功");
                    $state.go('app.my');
                });
            }

        }]);
    app.controller('accountCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });

        }]);
    app.controller('my_account_addCtrl', ["$scope","common","$ionicTabsDelegate", "$state", "myService", "msg"
        , function ($scope,common,$ionicTabsDelegate, $state, myService, msg) {
            $scope.addpict = function () {
                common.chooseImage().then(function (img) {
                    common.uploadFiles(img,1).then(function (result) {
                        var response = JSON.parse(result.response);
                        var file = response.data.file;
                        $scope.imgs.push(config.imgServer+file);
                    }, function (error) {
                        msg.error('图片上传失败');
                    });
                }, function (error) {
                    console.log('图片选择失败');
                });
            };
            $scope.addvideo = function () {
                common.chooseVideo().then(function (file) {
                    $scope.video.path = file;
                    common.uploadFiles(file, 2).then(function (result) {
                        var response = JSON.parse(result.response);
                        var file = response.data.file;
                        console.log("file:"+config.imgServer+file);
                        $scope.video.isOK = true;
                        $scope.video.server = config.imgServer+file;
                    }, function (error) {
                        msg.error('视频上传失败');
                    });
                }, function (erro) {
                    console.log('选择视频失败');
                });
            };
            $scope.deletefile = function (file) {
                var index = $scope.imgs.indexOf(file);
                $scope.imgs.splice(index, 1);
                common.deletefile(file).then(function () {
                })
            };
        }]);
    app.controller('messageCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });
            //系统消息
            $scope.systemInfo = function(){
                $state.go("app.my_message_sys");
                myService.systemInfo().then(function(result){
                },function(error){

                });
            };
            //回复我的
            $scope.replyMy = function(){
                $state.go("app.my_message_reply");
                myService.replyMy().then(function(result){
                    //$scope.comments = result;
                },function(error){

                });
            };
            $scope.personalLetter = function(){
                $state.go("app.personalLetter");
            }

        }]);
    app.controller('homeMessageCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
            });
            //系统消息
            $scope.systemInfo = function(){
                $state.go("app.message_sys");
                myService.systemInfo().then(function(result){
                },function(error){

                });
            };
            //回复我的
            $scope.replyMy = function(){
                $state.go("app.message_reply");
                myService.replyMy().then(function(result){
                    //$scope.comments = result;
                },function(error){

                });
            };
            $scope.personalLetter = function(){
                $state.go("app.letter");
            }


        }]);
    app.controller('dreamCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
  , function ($scope, $ionicTabsDelegate,$state, myService, msg) {
      $scope.$on('$ionicView.beforeEnter', function () {
          $ionicTabsDelegate.showBar(false);
            myService.myDream().then(function(result){
              $scope.dreams = result.data.data;
            });
          myService.myInfo().then(function(result){
              $scope.user = result.data.data
          });
      });
          $scope.toDetail = function (id) {
              $state.go('app.my_dreamdetail',{id:id});
          };

  }]);
    app.controller('collectCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg"
       , function ($scope, $ionicTabsDelegate,$state, myService, msg) {
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicTabsDelegate.showBar(false);
                myService.collect().then(function(result){
                    $scope.dreams = result.data.data.dreams;
                    $scope.users = result.data.data.users;
                });
            });
      $scope.toDetail = function (id) {
          $state.go('app.my_dreamdetail',{id:id});
      };
    }]);
    app.controller('messageSysCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
       , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
       }]);

    app.controller('sysCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
        }]);
    app.controller('letterCtrl', ["$scope", "$ionicTabsDelegate","$state", "myService", "msg"
        , function ($scope,$ionicTabsDelegate, $state, myService, msg) {
        }]);
    app.controller('messageReplyCtrl', ["$scope","$ionicTabsDelegate", "$state", "myService", "msg", "$ionicModal"
       , function ($scope,$ionicTabsDelegate, $state, myService, msg, $ionicModal) {
                $ionicModal.fromTemplateUrl('my-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
            });
            $scope.openModal = function () {
                $scope.modal.show();
            };

            $scope.closeModal = function () {
                $scope.modal.hide();

            };

            //我的回复
            $scope.vm={
                content:"",
                comment_id:""
            };
            $scope.myReplay = function(){
                var data = {
                    content:$scope.vm.content,
                    comment_id:$scope.vm.id
                };
                myService.myReplay(data).then(function(result){

                },function(error){

                });
                $scope.modal.hide();
            }
       }]);
   
})(angular.module('app.controllers'));