<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

/**
 * Migration auto-generated by Sequel Pro Laravel Export
 * @see https://github.com/cviebrock/sequel-pro-laravel-export
 */
class CreateBaseDictionaryOptionTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('base_dictionary_option', function (Blueprint $table) {
            $table->increments('id');
            $table->string('dictionary_table_code', 32)->comment('数据字典表');
            $table->string('dictionary_code', 32)->comment('数据字典代码');
            $table->string('key', 21)->comment('程序中使用，数据库使用value');
            $table->string('value', 32)->comment('编码');
            $table->string('name', 256)->comment('名称');
            $table->string('input_code', 256)->comment('输入码，通常用于保留拼音');
            $table->integer('sort')->comment('排序');
            $table->timestamps();
            $table->softDeletes();

            $table->index(['dictionary_table_code', 'dictionary_code'], 'idx_table_code');
            $table->index('deleted_at', 'idx_deleted_at');

            

        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('base_dictionary_option');
    }
}
