<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

/**
 * Migration auto-generated by Sequel Pro Laravel Export
 * @see https://github.com/cviebrock/sequel-pro-laravel-export
 */
class CreateUserInfoTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('user_info', function (Blueprint $table) {
            $table->increments('id')->comment('用户ID');
            $table->char('phone',11)->unique()->comment('电话');
            $table->string('password',100)->default('')->comment('密码');
            $table->string('nickname',100)->default('')->comment('昵称');
            $table->string('avatar')->default('')->comment('用户头像');
            $table->date('birthday')->default('2000-06-21');
            $table->integer('sign')->default(0)->comment('用户标签');
            $table->integer('money')->default(0)->comment('现金余额');
            $table->integer('coin')->default(0)->comment('梦想币余额');
            $table->tinyInteger('sex')->default(1)->comment('性别');
            $table->string('signture',200)->default('')->comment('个性签名');
            $table->integer('height')->default(0)->comment('身高');
            $table->string('work',20)->default('')->comment('职业');
            $table->tinyInteger('emotion')->default(1)->comment('情感状态');
            $table->string('address')->default('')->comment('省市区地址');
            $table->string('city')->comment('城市')->default('');
            $table->string('detail_address')->default('')->comment('详细地址');
            $table->tinyInteger('status')->default(1)->comment('状态');
            $table->string('wechat')->default('')->comment('微信id');
            $table->string('weibo')->default('')->comment('微博id');
            $table->string('remember_token')->default('')->comment('token');
            $table->timestamps();
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('user_info');
    }
}
