@extends('admin.layout') 

@section('content')
<div class="wrapper wrapper-content animated fadeInRight">
	<div class="row">
		<div class="col-sm-12">
			<div class="ibox float-e-margins">
				<div class="ibox-title">
					<h5>梦想列表</h5>
					<div class="ibox-tools">
						<a class="collapse-link"> <i class="fa fa-chevron-up"></i>
						</a>
					</div>
				</div>
				<div class="ibox-content">
				    <div class="row">
				        <form method="GET" action="" accept-charset="UTF-8">

				        <div class="col-sm-4">
				            <div class="input-group">
								<input type="text" value="{{Request::get('keyword')}}"	placeholder="id/用户id/梦想名称" name="keyword"class="input-sm form-control">
								<span class="input-group-btn">
									<button type="submit" class="btn btn-sm btn-primary">搜索</button>
								</span>
    						</div>
				        </div>
				        </form>
						@if(role('Dream/Info/create'))
    					<div class="col-sm-3 pull-right">
    					   <a href="{{ U('Dream/Info/create')}}" class="btn btn-sm btn-primary pull-right">添加</a>
    					</div>
						@endif
					</div>
					
					<table class="table table-striped table-bordered table-hover dataTables-example dataTable">
						<thead>
    						<tr>
								
            <th class="sorting" data-sort="id"> id </th>
            <th class="sorting" data-sort="user_id"> 用户ID </th>
            <th class="sorting" data-sort="name"> 梦想名称 </th>
            <th class="sorting" data-sort="coin"> 所需梦想币 </th>
            <th class="sorting" data-sort="get_coin"> 获得梦想币 </th>
			<th class="sorting" data-sort="mark"> 梦想分 </th>
			<th class="sorting" data-sort="sign"> 梦想标签 </th>
			<th class="sorting" data-sort="parameter"> 排行参数 </th>
			<th class="sorting" data-sort="code"> 二维码 </th>
			<th class="sorting" data-sort="status"> 梦想状态 </th>
			<th class="sorting" data-sort="created_at"> 梦想发布时间 </th>
			<th class="sorting" data-sort="end_time"> 梦想结束时间 </th>
								<th width="22%">相关操作</th>
        					</tr>
						</thead>
						<tbody>
						@if(isset($list))
							@foreach($list as $key => $item)							<tr>
								
            <td>{{ $item->id }}</td>
            <td>{{ $item->user_id }}</td>
            <td>{{ $item->name }}</td>
            <td>{{ $item->coin }}</td>
            <td>{{ $item->get_coin }}</td>
			<td>{{ $item->mark }}</td>
			<td>{{ $item->sign }}</td>
			<td>{{ $item->parameter }}</td>
			<td>
				<a onclick="layer.open({type: 2,area: ['80%', '90%'],content: '{{ U('/Dream/Info/show_code',['code'=> $item->code])}}'});"  class="btn btn-primary ">查看</a>
			</td>
			<td>{{ dict()->get('dream_info','status',$item->status) }}</td>
			<td>{{$item->created_at }}</td>
			<td>{{$item->end_time}}</td>
								<td>
									<div class="btn-group">
										<button data-toggle="dropdown"
											class="btn btn-warning btn-sm dropdown-toggle"
											aria-expanded="false">
											操作 <span class="caret"></span>
										</button>
										<ul class="dropdown-menu">


											@if(role('Dream/Info/update'))
											<li><a href="{{ U('Dream/Info/update',['id'=>$item->id])}}" class="font-bold">修改</a></li>
											@endif

											@if(role('Dream/Info/destroy'))
											<li class="divider"></li>
											<li><a href="{{ U('Dream/Info/destroy',['id'=>$item->id])}}" onclick="return confirm('你确定执行删除操作？');">删除</a></li>
											@endif

										</ul>
									</div>
								@if(role('Dream/Info/view'))
										<button onclick="layer.open({type: 2,area: ['80%', '90%'],content: '{{ U('Dream/Info/view',['id'=>$item->id])}}'});"  class="btn btn-primary ">查看更多</button>
									@endif
									<a href = "{{ U('Interaction/Info/view',['id'=>$item->id])}} " class="btn btn-primary ">查看动态</a>
								</td>
							</tr>
							@endforeach
							@endif

						</tbody>
					</table>
					<div class="row">
						<div class="col-sm-6">
							<div class="dataTables_info" id="DataTables_Table_0_info"
								role="alert" aria-live="polite" aria-relevant="all">每页{{ $list->count() }}条，共{{ $list->lastPage() }}页，总{{ $list->total() }}条。</div>
						</div>
						<div class="col-sm-6">
						<div class="dataTables_paginate paging_simple_numbers" id="DataTables_Table_0_paginate">
						{!! $list->setPath('')->appends(Request::all())->render() !!}
						</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
@endsection