@extends('admin.layout')

@section('content')
	<div class="wrapper wrapper-content animated fadeInRight">
		<div class="row">
			<div class="col-sm-12">
				<div class="ibox float-e-margins">
					<div class="ibox-title">
						<h5>提现列表</h5>
						<div class="ibox-tools">
							<a class="collapse-link"> <i class="fa fa-chevron-up"></i>
							</a>
						</div>
					</div>
					<div class="ibox-content">
						<div class="row">
							<form method="GET" action="" accept-charset="UTF-8">

								<div class="col-sm-4">
									<div class="input-group">
										<input type="text" value="{{Request::get('keyword')}}"	placeholder="请输入关键词" name="keyword"class="input-sm form-control">
								<span class="input-group-btn">
									<button type="submit" class="btn btn-sm btn-primary">搜索</button>
								</span>
									</div>
								</div>
							</form>
							@if(role('User/Cash/Out/create'))
								<div class="col-sm-3 pull-right">
									<a href="{{ U('User/Cash/Out/create')}}" class="btn btn-sm btn-primary pull-right">添加</a>
								</div>
							@endif
						</div>

						<table class="table table-striped table-bordered table-hover dataTables-example dataTable dataCheckTable">
							<thead>
							<tr>
								<th><input class="btSelectAll" name="btSelectAll" type="checkbox"></th>
								
            <th class="sorting" data-sort="id"> 提现记录id </th>
            <th class="sorting" data-sort="user_id"> 提现用户id </th>
            <th class="sorting" data-sort="bank_id"> 绑定的提现方式id </th>
            <th class="sorting" data-sort="status"> 提现状态: 0, 申请提现; 1,审核通过; 2,已打款; 3,审核未通过 </th>
            <th class="sorting" data-sort="cash"> 提现金额 </th>
            <th class="sorting" data-sort="created_at">  </th>
            <th class="sorting" data-sort="updated_at">  </th>
								<th width="22%">相关操作</th>
							</tr>
							</thead>
							<tbody>
							@if(isset($list))
								@foreach($list as $key => $item)
									<tr>
									<td><input data-json='{!! json_encode($item) !!}'  name="btSelectItem" class="data_key" type="checkbox" value="{{ $item->id or 0 }}" /></td>
									
            <td>{{ $item->id }}</td>
            <td>{{ $item->user_id }}</td>
            <td>{{ $item->bank_id }}</td>
            <td>{{ $item->status }}</td>
            <td>{{ $item->cash }}</td>
            <td>{{ $item->created_at }}</td>
            <td>{{ $item->updated_at }}</td>
									<td>
										@if(role('User/Cash/Out/view'))
											<button onclick="layer.open({type: 2,area: ['80%', '90%'],content: '{{ U('User/Cash/Out/view',['id'=>$item->id])}}'});"  class="btn btn-primary ">查看</button>
										@endif
									</td>
								</tr>
								@endforeach
							@endif

							</tbody>
						</table>
						<div class="row">
							<div class="col-sm-6">
								<div class="dataTables_info" id="DataTables_Table_0_info"
									 role="alert" aria-live="polite" aria-relevant="all">每页{{ $list->count() }}条，共{{ $list->lastPage() }}页，总{{ $list->total() }}条。</div>
							</div>
							<div class="col-sm-6">
								<div class="dataTables_paginate paging_simple_numbers" id="DataTables_Table_0_paginate">
									{!! $list->setPath('')->appends(Request::all())->render() !!}
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	@include('admin.tools.check_script');

@endsection